"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Button = void 0;
const react_1 = __importStar(require("react"));
const native_1 = __importStar(require("@emotion/native"));
const react_2 = require("@emotion/react");
const react_native_reanimated_1 = require("react-native-reanimated");
const values_js_1 = __importDefault(require("values.js"));
const RippleEffect_1 = require("@procyon/components/RippleEffect");
const color_1 = require("@procyon/utils/color");
const Button = (props) => {
    const { disabled, onClick, color = 'primary', size = 'md', children, variant = 'contained', style, } = props;
    const rippleAnimateRef = (0, react_native_reanimated_1.useAnimatedRef)();
    const [hover, setHover] = (0, react_1.useState)(false);
    const theme = (0, react_2.useTheme)();
    const rippleColor = (0, react_1.useMemo)(() => {
        const val = new values_js_1.default(theme.palette[color].main);
        if ((0, color_1.isDark)(val.rgb)) {
            return val.tint(30).rgbString();
        }
        else {
            return val.shade(30).rgbString();
        }
    }, [color]);
    return (react_1.default.createElement(ButtonContainer, { variant: variant, "aria-label": "button", color: color, onPress: (...args) => onClick === null || onClick === void 0 ? void 0 : onClick(...args), hover: hover, onHoverIn: () => setHover(true), onHoverOut: () => setHover(false), style: [style === null || style === void 0 ? void 0 : style.container], disabled: disabled, collapsable: false, ref: rippleAnimateRef },
        react_1.default.createElement(RippleEffect_1.RippleEffect, { ref: rippleAnimateRef, disabled: disabled, color: rippleColor, style: {
                container: [
                    (0, native_1.css)({
                        borderRadius: theme.rounded.md,
                        alignItems: 'center',
                    }),
                    style === null || style === void 0 ? void 0 : style.container,
                ],
            } },
            react_1.default.createElement(ButtonText, { variant: variant, size: size, color: color, style: [style === null || style === void 0 ? void 0 : style.text] }, children))));
};
exports.Button = Button;
const ButtonContainer = native_1.default.Pressable(({ theme }) => ({
    borderRadius: theme.rounded.md,
    backgroundColor: 'transparent',
}), ({ theme, variant, color, hover, disabled }) => (Object.assign(Object.assign(Object.assign({}, (variant === 'contained'
    ? Object.assign(Object.assign({ backgroundColor: theme.palette[color].main }, (hover && {
        backgroundColor: new values_js_1.default(theme.palette[color].main).shade(5).rgbString(),
    })), (disabled && {
        backgroundColor: new values_js_1.default(theme.palette.base.main).tint(60).rgbString(),
    })) : {})), (variant === 'outlined'
    ? Object.assign(Object.assign({ borderWidth: 2, borderColor: theme.palette[color].main }, (hover && {
        backgroundColor: new values_js_1.default(theme.palette[color].main).tint(90).rgbString(),
    })), (disabled && {
        borderColor: new values_js_1.default(theme.palette.base.main).tint(60).rgbString(),
    })) : {})), (variant === 'text'
    ? Object.assign({}, (hover && {
        backgroundColor: new values_js_1.default(theme.palette[color].main).tint(90).rgbString(),
    })) : {}))));
const ButtonText = native_1.default.Text(({ theme, size }) => ({
    fontFamily: theme.fontFamily,
    padding: theme.spacing[size] + 2,
    fontSize: theme.fontSize[size],
    fontWeight: 'normal',
    userSelect: 'none',
    textTransform: 'uppercase',
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',
    gap: 4,
}), ({ theme, disabled, variant, color }) => (Object.assign(Object.assign(Object.assign({}, (variant === 'contained'
    ? {
        color: (0, color_1.isDark)(new values_js_1.default(theme.palette[color].main).rgb)
            ? theme.palette[color].light
            : theme.palette[color].dark,
    }
    : {})), (variant === 'outlined' || variant === 'text'
    ? {
        color: theme.palette[color].dark,
    }
    : {})), (disabled
    ? {
        color: theme.palette.disabled,
    }
    : {}))));
