import React, { FC } from 'react';
import { ListData, ListProps } from '@procyon/components/List';
import { InputElementType } from '@procyon/types/form';
import { TextFieldProps } from './TextField';
export type ItemWithLabel = {
    id: ListData['id'];
    label: string;
};
export type ItemWithoutLabel = {
    id: ListData['id'];
};
type GetLabel<Item extends ListData> = {
    getLabel: (item: Item) => string;
};
export type SelectboxProps<Items extends ItemWithLabel[] | ItemWithoutLabel[]> = {
    Input?: FC<TextFieldProps & {
        data: Items;
    }>;
    Item?: ListProps<Items>['Item'];
    clearable?: boolean;
    data?: Items;
} & InputElementType<string | number> & (Items extends ItemWithLabel[] ? Partial<GetLabel<Items[0]>> : GetLabel<Items[0]>);
export declare const Selectbox: <Items extends ListData[]>(props: SelectboxProps<Items>) => React.JSX.Element;
export declare const FieldText: import("@emotion/native").StyledComponent<import("react-native").TextProps & {
    theme?: import("@emotion/react").Theme | undefined;
    as?: React.ElementType<any, keyof React.JSX.IntrinsicElements> | undefined;
} & {
    size?: SelectboxProps<any>['size'];
}, {}, {
    ref?: React.Ref<import("react-native").Text> | undefined;
}>;
export {};
