"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FieldText = exports.Selectbox = void 0;
const react_1 = __importDefault(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const lucide_react_native_1 = require("lucide-react-native");
const react_native_1 = require("react-native");
const react_native_reanimated_1 = require("react-native-reanimated");
const tiny_invariant_1 = __importDefault(require("tiny-invariant"));
const List_1 = require("@procyon/components/List");
const context_1 = require("@procyon/components/Modal/context");
const TextField_1 = require("./TextField");
const Selectbox = (props) => {
    const { value, onChange, label, message, name, data, Input = DefaultInput, Item, getLabel } = props, others = __rest(props, ["value", "onChange", "label", "message", "name", "data", "Input", "Item", "getLabel"]);
    const viewRef = (0, react_native_reanimated_1.useAnimatedRef)();
    const [openModal, closeModal, { opened }] = (0, context_1.useModal)(name, {
        Component: ({ viewStyle }) => (react_1.default.createElement(react_native_1.View, { style: [viewStyle] },
            react_1.default.createElement(List_1.List, { Item: Item, selected: value, data: data, getLabel: getLabel, onClick: (event, id) => {
                    event.preventDefault();
                    onChange === null || onChange === void 0 ? void 0 : onChange(event, id);
                    closeModal();
                }, style: {
                    container: [
                        {
                            marginHorizontal: 0,
                            marginBottom: 10,
                        },
                    ],
                    list: {
                        maxHeight: 300,
                    },
                } }))),
    });
    const handleOpenOptions = () => {
        if (opened.includes(name)) {
            closeModal();
            return;
        }
        (0, react_native_reanimated_1.runOnUI)(() => {
            const layout = (0, react_native_reanimated_1.measure)(viewRef);
            if (!layout) {
                (0, tiny_invariant_1.default)('Unable to measure element for obtain position!');
                return null;
            }
            (0, react_native_reanimated_1.runOnJS)(openModal)({
                props: {
                    viewStyle: {
                        position: 'absolute',
                        width: layout.width,
                        top: layout.y + 65,
                        left: layout.x,
                    },
                },
                style: {
                    wrapper: {
                        backgroundColor: 'transparent',
                    },
                },
            });
        })();
    };
    return (react_1.default.createElement(react_native_1.View, { style: { position: 'relative' }, ref: viewRef },
        react_1.default.createElement(TextField_1.TextField, Object.assign({}, others, { label: label, onBlur: (e) => {
                var _a;
                (_a = others.onBlur) === null || _a === void 0 ? void 0 : _a.call(others, e, value);
            }, onFocus: (e) => {
                var _a;
                (_a = others.onFocus) === null || _a === void 0 ? void 0 : _a.call(others, e, value);
            }, Input: (props) => (react_1.default.createElement(Input, Object.assign({}, props, { data: data, getLabel: getLabel, value: value === null || value === void 0 ? void 0 : value.toString() }))), message: message, onClick: handleOpenOptions, RightIcon: (props) => (react_1.default.createElement(react_native_1.Pressable, { onPressIn: handleOpenOptions, style: [react_native_1.Platform.OS === 'web' && { cursor: 'pointer' }] },
                react_1.default.createElement(lucide_react_native_1.ChevronDownIcon, Object.assign({}, props)))) }))));
};
exports.Selectbox = Selectbox;
const DefaultInput = ({ value, data, getLabel, }) => {
    const item = data === null || data === void 0 ? void 0 : data.find((item) => item.id.toString() === value && !!value);
    if (!item)
        return null;
    return react_1.default.createElement(exports.FieldText, null, getLabel ? getLabel(item) : item.label);
};
exports.FieldText = native_1.default.Text(({ theme, size = 'md' }) => {
    return Object.assign(Object.assign({}, (react_native_1.Platform.OS === 'web' && { cursor: 'pointer' })), { color: theme.palette.text.main, fontFamily: theme.fontFamily, fontSize: theme.fontSize[size] });
});
